import { PublicKey } from '@solana/web3.js';
import { LiquidityIncentiveClient } from '../../client/liquidityIncentiveProgram';
import { CampaignState, ErrorCB } from '../../types';
import { StateUpdateHandler } from '../../types/index';
export declare class Campaign {
    readonly client: LiquidityIncentiveClient;
    readonly address: PublicKey;
    state: CampaignState;
    private _onStateUpdate?;
    private _errorCallback?;
    private _listener;
    constructor(client: LiquidityIncentiveClient, address: PublicKey, state: CampaignState, _onStateUpdate?: StateUpdateHandler<CampaignState>, _errorCallback?: ErrorCB);
    static load(client: LiquidityIncentiveClient, address: PublicKey, onStateUpdateHandler?: StateUpdateHandler<CampaignState>, errorCallback?: ErrorCB): Promise<Campaign>;
    subscribe(): void;
    rewardVaultAddress(): PublicKey;
    rewardVaultAuthorityAddress(): PublicKey;
    private addListener;
    private removeListener;
    unsubscribe(): Promise<void>;
}
